<template>
  <div class="bla">
    <Error v-if="error" :error.sync="error" round class="mv-5"/>

    <h2 class="mh-5 mt-1 mb-0"><i>{{ tok ? `VALIDATING` : `VALIDATE` }}</i></h2>

    <p v-if="!tok">
      {{ msg ? `${msg}.` : 'Please verify your email to continue.' }}
    </p>

    <button v-if="!tok" class="mt-2 mb-5 primary"
      :disabled="canResendIn || resending" @click="resendEmail">
      {{ canResendIn ? `Resend available in ${canResendIn}s` : 'Resend Email' }}
    </button>
    <v-icon v-else name="circle-notch" spin scale="1.5" class="mv-2"/>

    <Policy by="clicking Resend Email"/>
  </div>
</template>

<script>
import Policy from '@/components/Policy.vue';
import axios from 'axios';

export default {
  data: () => ({
    tok: null,
    msg: null,
    canResendIn: null,
    count: 1,
    resending: false,
    error: null,
  }),
  components: {
    Policy,
  },
  methods: {
    startResendCountdown() {
      this.canResendIn = this.count * 15;
      setTimeout(this.resendTick, 1000);
      this.count++;
    },
    resendTick() {
      if (this.canResendIn > 1) {
        this.canResendIn--;
        setTimeout(this.resendTick, 1000);
      } else {
        this.canResendIn = null;
      }
    },
    resendEmail() {
      if (this.canResendIn)
        return ;

      this.msg = null;
      this.error = null;
      this.resending = true;

      axios.post('/api/auth/revalidate')
        .then(({ data }) => {
          if (data.msg == 'ALREADY_VERIFIED') {
            this.$store.commit('setUser', null);
            this.$router.push('/');
          }
          else
            this.msg = data.msg;
          // 4 * 15 = 60 seconds. Wait one minute before successful resend
          this.count = 4;
        })
        .catch((err) => {
          if (err.response)
            this.error = err.response.data.error;
          // No err.response indicates am unhandled internal error, so the
          // countdown is increased (since the bug probably won't be fixed soon)
          else {
            this.count += 2;
            err;
          }
        })
        .finally(() => {
          this.resending = false;
          this.startResendCountdown();
        });
    },
    validate() {
      this.error = null;
      axios.post(`/api/auth/validate/${this.tok}`)
        .then(({ data }) => {
          this.tok = null;
          this.msg = 'Verified successfully!';
          data.user.verified = true;
          this.$store.commit('setUser', data.user);
          localStorage.setItem('user', JSON.stringify(data.user));
          if (data.user.first_setup)
            this.$router.push('/');
          else
            this.$router.replace({ hash: '#setup' });
        })
        .catch(err => {
          if (err.response && err.response.data.error) {
            this.error = err.response.data.error;
            this.tok = null;
          }
          else
            err;
        });
    },
  },
  mounted() {
    if (this.$route.hash === '#validate' && this.$route.query.tok) {
      this.tok = this.$route.query.tok;
      this.validate();
    }
    else {
      this.startResendCountdown();
    }
  },
};
</script>
